/*global Ti, Titanium, alert, JSON, require, setTimeout, setInterval */
var notification = Ti.UI.createNotification({
	duration: Ti.UI.NOTIFICATION_DURATION_LONG
});
function toast(text)
{
	notification.hide();
	notification.message = text;
	notification.show();
}

Titanium.UI.setBackgroundColor('#000');
var win = Titanium.UI.createWindow({  
    title:'Test',
    backgroundColor:'#000',
	exitOnClose: true
});

var images = [
	"1.jpg",
	"2.jpg",
	"4.jpg",
	"7.jpg",
	"9.jpg"
];
var captions = [
	"That's a building in Verona.  Hi building in Verona!",
	"That's the river in Verona, or maybe a canal. I don't know!",
	"There's a man on the other side of the river-or-canal.  Hi Man!",
	"Another shot across the river/canal.",
	"Some plaza somewhere"
];
var bgColors = [
	"red",
	"green",
	"blue",
	"yellow",
	"magenta"
];
var textColors = [
	"white",
	"black",
	"yellow",
	"blue",
	"white"
];

function makePadButton(title, left, click) {
	var btn = Ti.UI.createButton({
		title: title,
		top: "0dp", left: left, width: "150dp", height: "auto"
	});
	btn.addEventListener("click", click);
	return btn;
}

var nextViewIndex = 0;
function makeView(image, caption, bgColor, textColor) {
	var v = Ti.UI.createView({
		width: "auto",
		height: "auto",
		top: 0, left: 0,
		backgroundColor: bgColor,
		viewIndex: nextViewIndex
	});
	var img = Ti.UI.createImageView({
		image: image,
		top: "15dp", left: "15dp",
		width: "85dp", height: "57dp"
	});
	img.addEventListener("click", function() {
		toast("You clicked the image");
	});
	v.add(img);
	var lbl = Ti.UI.createLabel({
		text: "(" + nextViewIndex + ") " + caption,
		top: "15dp",
		left: "110dp",
		width: "180dp",
		height: "auto",
		color: textColor
	});
	lbl.addEventListener("click", function() {toast("You clicked the label");});
	v.add(lbl);
	/*
	v.add(Ti.UI.createTextField({
		top: "15dp",
		left: "110dp",
		width: "180dp",
		height: "auto"
	}));
	*/
	nextViewIndex ++;
	return v;
}

function buildFirstViewSet() {
	var viewset = [];
	for (var i = 0; i < images.length; i++)
	{
		viewset.push(makeView(images[i], captions[i], bgColors[i], textColors[i]));
	}
	return viewset;
}
var views = buildFirstViewSet();

var topConsole = Ti.UI.createLabel({
	top: "0dp",
	left: "10dp",
	right: "10dp",
	height: "40dp",
	borderRadius: 5,
	color: "yellow",
	backgroundColor: "blue"
});
win.add(topConsole);
	

var vp = Ti.UI.createScrollableView({
	top: "50dp",
	left: "10dp",
	right: "10dp",
	height: "90dp",
	views: views
});
win.add(vp);

vp.addEventListener("scroll", function(e) {
	topConsole.text = "Scroll event. Current Page: " + e.currentPage;
});

var pad = Ti.UI.createScrollView({
	left: "10dp", right: "10dp",
	top: "150dp", height: "auto",
	layout: "vertical"
});
win.add(pad);

var row1 = Ti.UI.createView({
	left: "0dp", right: "0dp",
	height: "auto", top: "0dp"
});
pad.add(row1);
row1.add(makePadButton("Move Prev", "0dp", function() {vp.movePrevious();}));
row1.add(makePadButton("Move Next", "155dp", function() {vp.moveNext();}));
pad.add(row1);

var row2 = Ti.UI.createView({
	top: "10dp", left: "0dp", right: "0dp",
	height: "auto"
});
pad.add(row2);
row2.add(makePadButton("Move to index 2", "0dp", function() {vp.scrollToView(2);}));
row2.add(makePadButton("Move to view index 3", "155dp", function() {vp.scrollToView(views[3]);}));


var row3 = Ti.UI.createView({
	top: "10dp", left: "0dp", right: "0dp",
	height: "auto"
});
pad.add(row3);
row3.add(makePadButton("Get Views", "0dp", function() {
	var vv = vp.views;
	alert("Length " + vv.length + " of type " + vv[0]);
}));
row3.add(makePadButton("currentPage (get)", "155dp", function() {alert(vp.currentPage);}));

var row4 = Ti.UI.createView({
	top: "10dp", left: "0dp", right: "0dp",
	height: "auto"
});
pad.add(row4);
row4.add(makePadButton("currentPage (set to 1)", "0dp", function() {vp.currentPage = 1;}));
row4.add(makePadButton("Add View", "155dp", function() {
	var rnd = Math.random();
	var idx = Math.floor(rnd * images.length);
	vp.addView(makeView(images[idx], captions[idx], bgColors[idx], textColors[idx]));
}));

var row5 = Ti.UI.createView({
	top: "10dp", left: "0dp", right: "0dp",
	height: "auto"
});
pad.add(row5);
row5.add(makePadButton("Remove random", "0dp", function() {
	var views = vp.views;
	var count = views.length;
	if (count === 0) {
		alert("Nothing left to remove.");
		return;
	}
	var rnd = Math.random();
	var idx = Math.floor(rnd * count);
	Ti.API.info("Randomizer check.  Count is " + count + ", rnd is " + rnd + ", resulting random idx is " + idx);
	vp.removeView(views[idx]);
	alert("Removed at index " + idx);
}));
row5.add(makePadButton("Remove at index 1", "155dp", function() {vp.removeView(vp.views[1]);}));

var row6 = Ti.UI.createView({
	top: "10dp", left: "0dp", right: "0dp",
	height: "auto"
});
pad.add(row6);
row6.add(makePadButton("Toggle paging ctrl", "0dp", function() {vp.showPagingControl = !vp.showPagingControl;}));
row6.add(makePadButton("set .views", "155dp", function() {
	views = buildFirstViewSet();
	vp.views = views;
}));



win.open();
